/*
 * uuname - print names of all uucp remote systems, or just local (-l) system.
 *
 * Copyright (c) 1988 Ian Darwin, Toronto, Canada.
 * $Header: uuname.c,v 1.4 90/02/22 19:41:28 gnu Exp $
 * This program may be copied under the terms of the FSF copyleft.
 *
 * Will have to be installed setuid or setgid uucp on most UNIXes.
 */

#include "includes.h"
#include "uucp.h"

extern int debug;

extern s_or_f read_params();

int	local_only = 0;
char	*progname;
void	exit();

/*
 * main - parse arguments and handle options
 */
main(argc, argv)
int argc;
char *argv[];
{
	int c, errflg = 0;
	extern int optind;
	extern char *optarg;

	progname = argv[0];

	while ((c = getopt(argc, argv, "lx:C:")) != EOF)
		switch (c) {
		case 'l':
			local_only++;
			break;
		case 'x':
			debug = atoi(optarg);
			break;
		case 'C':
			Control = optarg;
			break;
		case '?':
		default:
			errflg++;
			break;
		}

	if (errflg || optind<argc) {
		(void) fprintf(stderr, "usage: %s [-l] [-xN] [-Cfile]\n", progname);
		exit(2);
	}

	if (read_params(Control) != SUCCESS)	/* Read control file */
		exit(1);

	if (local_only) {
		printf("%s\n", Myname);
		exit(0);
	} else {
		exit(print_remotes());
	}
}

/*
 * print_remotes() - print list of remotes
 */
int
print_remotes()
{
	char buf[MAX_LSYS], this_entry[100], old_entry[100];
	FILE *systemsfile;

	if ((systemsfile = fopen(Sysfile, "r")) == NULL) {
		fprintf(stderr, "%s: can't open systems file %s\n",
			progname, Sysfile);
		return 1;
	}

	/* FIXME use geoff collyer's mfgets() to read continued lines */
	while (fgets(buf, sizeof buf, systemsfile) != NULL) {
		if (*buf == '#')
			continue;
		(void) sscanf(buf, "%s", this_entry);
		/*
		 * some systems have multiple lines, print each name 
		 * only once (assume sorted)
		 * FIXME should we read whole thing in and 
		 *	qsort(3) it to be SURE of getting dups?
		 *	I think not - nice guys KEEP their sysfiles in order.
		 */
		if (strcmp(this_entry, old_entry) == 0)
			continue;
		put_entry(this_entry);
		strcpy(old_entry, this_entry);
	}

	(void) fclose(systemsfile);
	return 0;
}

put_entry(entry)
char *entry;
{
	/*
	 * Sermon: if you feel you really and truly MUST add columnation here:
	 * 1) Read the essay "Program Design in the UNIX Environment"
	 *    by Kernighan and Pike, AT&T BLTJ, October, 1984.
	 * 2) Repeat the previous step until you no longer feel
	 *    the urge to add columnation here.
	 * 3) If you STILL feel you REALLY AND TRULY **MUST**
	 *    add columnation, at least:
	 *	3a) keep all such grot in this function, and
	 *	3b) use the "-C" option like Berkeley and System V "ls" do.
	 * End of sermon.
	 */
	printf("%s\n", entry);
}
